<?php

namespace Webkul\Supportticket\Http\Controllers\Admin;

use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Webkul\Supportticket\Repositories\SupportticketRepository;
use Webkul\Customer\Repositories\CustomerRepository;
use Illuminate\Supportticket\Facades\DB;
use Webkul\Admin\DataGrids\SupportDataGrid;

class SupportticketController extends Controller
{
    /**
     * Contains route related configuration.
     *
     * @var array
     */
    protected $_config;

    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct(
        protected CustomerRepository $customerRepository,
        protected SupportticketRepository $supportRepository
        )
    {
        $this->_config = request('_config');
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\View\View
     */
    public function index()
    {        
        if (request()->ajax()) {            
            return app(SupportDataGrid::class)->toJson();
        }
        return view($this->_config['view']);      
    }  
    
    public function view($id) {       
        $ticketDetail = $this->supportRepository->getTicketDetailsById($id);
        return view($this->_config['view'], compact('ticketDetail'));
    }

    public function sendmessage(Request $request){
        $roleID = session('user_role');        
        $data = $request->all();        
        $result = array(
            'type'      => 'ticket',
            'frommsg'   => '1',
            'tomsg'     => $data['customerid'],
            'bookingid' => $data['ticketid'],
            'message'   => $data['message'],
            'status'    => '1'
        );  
        $output = $this->supportRepository->saveMessage($result);
        if($output==true){
            return 'Message sent';
        } else {
            return 'Failed, Try again.';
        }
    }

    public function loadmessage($type,$bookingid)
    {
        $result = $this->supportRepository->getAllMessages($type,$bookingid);        
        $html = '';
        foreach($result as $value){

            $date = date('m/d/Y H:i a', strtotime($value->created_at));

            $fromUser = $this->customerRepository->find($value->frommsg);
            $fromName = ucfirst($fromUser->first_name.' '.$fromUser->last_name);
            //$toUser = $this->customerRepository->find($value->tomsg);
            if(1==$value->frommsg){
                $floatMsg = 'class="chatSender"';
            }else{
                $floatMsg = 'class="charRecever"';
            }
            $html .= '<div '.$floatMsg.'><span class="senderName">'.$fromName.'</span>';
            $html .= '<span class="msg">&nbsp;'.ucfirst($value->message).'</span><br/><span class="date">'.$date.'</span></div>';
        }        
        return $html;
    }

    public function updateticket(Request $request){
        $data = $request->all();

        $post = array(
            'ticket_id' => $data['supportticketid'],
            'ticket_status' => $data['supportstatus']
        );

        $output = $this->supportRepository->updateTicket($post);

        if($output==true){
            session()->flash('success', trans('Support ticket is closed successfully.'));
            return redirect()->route('admin.settings.supportticket.index');
        }else{
            return back()->with('fail','Data not Deleted!');
        }        
    }
}
