<?php

namespace Webkul\Supportticket\Repositories;

use Webkul\Core\Eloquent\Repository;
use Webkul\Supportticket\Contracts;
use DB;
class SupportticketRepository extends Repository
{
    /**
     * Specify Model class name
     *
     * @return mixed
     */
    function model()
    {
        return 'Webkul\Supportticket\Contracts\Supportticket';
    }

    /**
     * Return Filtered Custom resources
     *
     * @return objects
     */ 
    
    public function getTicketDetailsById($id){
        if(isset($id)){
            $result = DB::table('support_ticket')->where('id',$id)->first();
            return $result;
        }else{
            return [];
        }

    }

    public function saveMessage($data){
        $query = DB::table('messages')->insert([
             'type'          => $data['type'],
             'frommsg'       => $data['frommsg'],
             'tomsg'         => $data['tomsg'],
             'bookingid'     => $data['bookingid'],
             'message'       => $data['message'],
             'status'        => $data['status']
         ]);
 
         if($query){
             return true;
         }else{
             return false;
         }
    }

    public function getAllMessages($type, $bookid){
        if(isset($type) && isset($bookid)){
            $result = DB::table('messages')->where('type', $type)->where('bookingid', $bookid)->orderBy('id', 'ASC')->get();
            return $result;
        }else{
            return [];
        }
    }

    public function updateTicket($data){
        $query = DB::table('support_ticket')->where('id', $data['ticket_id'])->update(array('status' => $data['ticket_status']));

        if($query){
            return true;
        }else{
            return false;
        }
    }
}